/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 * 
 *  DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 *  This code is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License version 3, 
 *  or (at your option) any later version, as published by the Free Software Foundation.  
 *  The authors designate this particular file as subject to the "Classpath" exception 
 *  as provided in the LICENSE file that accompanied this code.
 *
 *  This code is distributed in the hope that it will be useful, but WITHOUT
 *  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  version 3 for more details (a copy is included in the LICENSE file that
 *  accompanied this code).
 *
 *  You should have received a copy of the GNU General Public License version 3
 *  along with this work; if not, see http://www.gnu.org/licenses/gpl-3.0.txt 
 *
 *  Please contact visnow.org or visit www.visnow.org if you need additional information or
 *  have any questions.
 *
 */

package org.visnow.vn.lib.basic.writers.UCDWriter;

import java.io.File;
import javax.swing.JFileChooser;
import javax.swing.filechooser.FileNameExtensionFilter;
import org.visnow.vn.system.main.VisNow;
import org.visnow.vn.system.swing.filechooser.VNFileChooser;

public class GUI extends javax.swing.JPanel
{

    private String path = null;
    private String lastPath = null;
    protected Params params = new Params();

    /**
     * Creates new form EmptyVisnowModuleGUI
     */
    public GUI()
    {
        initComponents();
    }

    /**
     * Set the value of params
     *
     * @param params new value of params
     */
    public void setParams(Params params)
    {
        this.params = params;
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {
        java.awt.GridBagConstraints gridBagConstraints;

        fileChooser = new javax.swing.JFileChooser();
        selectButton = new javax.swing.JButton();
        fileNameField = new javax.swing.JTextField();
        writeButton = new javax.swing.JButton();
        resultLabel = new javax.swing.JLabel();
        jLabel1 = new javax.swing.JLabel();

        setForeground(new java.awt.Color(156, 47, 74));
        setLayout(new java.awt.GridBagLayout());

        java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("org/visnow/vn/lib/basic/writers/UCDWriter/Bundle"); // NOI18N
        selectButton.setText(bundle.getString("GUI.selectButton.text_1")); // NOI18N
        selectButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                selectButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 1);
        add(selectButton, gridBagConstraints);

        fileNameField.setText(bundle.getString("GUI.fileNameField.text_1")); // NOI18N
        fileNameField.setMinimumSize(new java.awt.Dimension(4, 22));
        fileNameField.setPreferredSize(new java.awt.Dimension(78, 22));
        fileNameField.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                fileNameFieldActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(2, 0, 2, 0);
        add(fileNameField, gridBagConstraints);

        writeButton.setText(bundle.getString("GUI.writeButton.text_1")); // NOI18N
        writeButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                writeButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 1);
        add(writeButton, gridBagConstraints);

        resultLabel.setText(bundle.getString("GUI.resultLabel.text")); // NOI18N
        resultLabel.setVerticalAlignment(javax.swing.SwingConstants.TOP);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(6, 2, 0, 2);
        add(resultLabel, gridBagConstraints);

        jLabel1.setForeground(new java.awt.Color(153, 0, 0));
        jLabel1.setText(bundle.getString("GUI.jLabel1.text")); // NOI18N
        jLabel1.setMaximumSize(new java.awt.Dimension(1323, 140));
        jLabel1.setMinimumSize(new java.awt.Dimension(1323, 100));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jLabel1, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    private void fileNameFieldActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_fileNameFieldActionPerformed
    {//GEN-HEADEREND:event_fileNameFieldActionPerformed
        params.setFileName(fileNameField.getText());
        params.fireStateChanged();
    }//GEN-LAST:event_fileNameFieldActionPerformed

    private void writeButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_writeButtonActionPerformed
    {//GEN-HEADEREND:event_writeButtonActionPerformed
        if (params.getFileName() != null && params.getFileName().length() > 4 && VNFileChooser.checkForOverwrite(params.getFileName())) {
            params.fireStateChanged();
        }
    }//GEN-LAST:event_writeButtonActionPerformed

    public void setResultText(String s)
    {
        resultLabel.setText(s);
    }

    private void selectButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_selectButtonActionPerformed
    {//GEN-HEADEREND:event_selectButtonActionPerformed
        if (lastPath == null)
            fileChooser.setCurrentDirectory(new File(VisNow.get().getMainConfig().getDataWriterPath()));
        else
            fileChooser.setCurrentDirectory(new File(lastPath));

        FileNameExtensionFilter volFilter = new FileNameExtensionFilter("UCD files", "inp", "INP", "vnf", "VNF");
        fileChooser.addChoosableFileFilter(volFilter);

        int returnVal = fileChooser.showDialog(this, "Select");
        if (returnVal == JFileChooser.APPROVE_OPTION) {
            path = VNFileChooser.filenameWithExtenstionAddedIfNecessary(fileChooser.getSelectedFile(), volFilter);
            fileNameField.setText(path);
            lastPath = path.substring(0, path.lastIndexOf(File.separator));
            params.setFileName(path);
        }
    }//GEN-LAST:event_selectButtonActionPerformed
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JFileChooser fileChooser;
    private javax.swing.JTextField fileNameField;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel resultLabel;
    private javax.swing.JButton selectButton;
    private javax.swing.JButton writeButton;
    // End of variables declaration//GEN-END:variables
}
